import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;

/*
* This is the Server side of the program
* Default settings for port is 45000;
* If any client tries to connect to this port, server sends them the next port number.
* */

 public class Server {
    private static int port = 45000;

    /*log is informed when a client starts a connection on a new port, riches required port
    * or when something goes wrong and a client couldn't rich the required port.
    * */

     private static Logger log = Logger.getLogger(Server.class.getName());

    public static void main(String[] args) throws Exception {

        int counter = 0;

        while (port != 46000 && counter < 50) {
            ServerSocket serverSocket = new ServerSocket(port);
            log.log(Level.INFO, "trying to connect using port " + port);
            Socket clientSocket = serverSocket.accept();
            PrintWriter out = new PrintWriter(clientSocket.getOutputStream(), true);

            Protocol protocol = new Protocol();
            port = protocol.processInput(counter);
            out.println(String.valueOf(port));

            serverSocket.close();
            clientSocket.close();
            counter++;
        }

        if (port == 46000) {

            Date curDate = new Date();
            SimpleDateFormat format = new SimpleDateFormat("yyyy:MM:dd HH:mm:ss");
            String dateToStr = format.format(curDate);

            ServerSocket serverSocket = new ServerSocket(port);
            Socket clientSocket = serverSocket.accept();
            PrintWriter out = new PrintWriter(clientSocket.getOutputStream(), true);
            out.println("Hello " + dateToStr);
            log.log(Level.INFO, "connected to the required port");
        } else{
            log.log(Level.WARNING, "Runout of attempts to connect");
            port = 45000;
        }


    }
}
