
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.Scanner;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

/**
 * This program uses as a parameter a link to google.com
 * you have to type your query in the console.
 */


public class WebSearch {

    public static void main(String[] args) throws Exception {

        Scanner scan = new Scanner(System.in);
        String google = args[0];
        String query = scan.nextLine();
        String charset = "UTF-8";
        String userAgent = "Mozilla/5.0 (Windows NT 6.1)";

        Elements links = Jsoup.connect(google + URLEncoder.encode(query, charset)).userAgent(userAgent).get().select("li.g>h3>a");

        for (Element link : links) {
            String title = link.text();
            String url = link.absUrl("href");
            url = URLDecoder.decode(url.substring(url.indexOf('=') + 1, url.indexOf('&')), "UTF-8");

            if (!url.startsWith("http")) {
                continue;
            }

            System.out.print("*" + title + " ");
            System.out.println("[" + url + "]");
        }

    }

}